var EventType;
(function (EventType) {
    EventType[EventType["TOUCH_START"] = 0] = "TOUCH_START";
    EventType[EventType["TOUCH_MOVE"] = 1] = "TOUCH_MOVE";
    EventType[EventType["TOUCH_END"] = 2] = "TOUCH_END";
    EventType[EventType["TOUCH_CANCEL"] = 3] = "TOUCH_CANCEL";
    EventType[EventType["MOUSE_DOWN"] = 4] = "MOUSE_DOWN";
    EventType[EventType["MOUSE_MOVE"] = 5] = "MOUSE_MOVE";
    EventType[EventType["MOUSE_ENTER"] = 6] = "MOUSE_ENTER";
    EventType[EventType["MOUSE_LEAVE"] = 7] = "MOUSE_LEAVE";
    EventType[EventType["MOUSE_UP"] = 8] = "MOUSE_UP";
    EventType[EventType["MOUSE_WHEEL"] = 9] = "MOUSE_WHEEL";
})(EventType = exports.EventType || (exports.EventType = {}));

var EventItem = cc.Class({
    name: 'EventItem',
    properties: {
        _eventType: {
            default: EventType.TOUCH_START,
            type: cc.Enum(EventType),
            visible: false,
        },
        eventType: {
            // displayName: "事件类型",
            type: cc.Enum(EventType),
            get() {
                return this._eventType;
            },
            set(value) {
                this._eventType = value;
            }
        },
        eventName: {
            // displayName: "事件名称",
            get() {
                return cc.Node.EventType[`${EventType[this.eventType]}`];
            },
        },
        eventEmits: {
            // displayName: "事件回调",
            type: cc.Component.EventHandler,
            default: []
        }
    }
});

cc.Class({
    extends: cc.Component,
    properties: {
        events: {
            // displayName: "所有事件",
            default: [],
            type: EventItem
        }
    },
});